__doc__ = """Z Photo Slides by JeanFranois Roche (jfroche@jfroche.be)"""

__version__='$Revision: 0.2 $'[11:-2]

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB
from OFS.Folder import Folder
from OFS.Image	import Image

import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import traceback
import os

#from Products.LocalFS.LocalDirectory import defaultDocument
from Products.LocalFS import LocalFS
from Products.PythonScripts import PythonScript

from IMG_start import MakeThumbnails
from image_modif import Image_modif

manage_addZPhotoSlidesForm = HTMLFile('ZPhotoSlidesAdd', globals())

def manage_addZPhotoSlides(self, id,photo_folder,thumb_prefix,title='', REQUEST=None):
    """Add a ZPhotoSlides to a folder."""
    img = LocalFS.LocalFS('img','coool',photo_folder,username=None,password=None)
    for tmpdir in ('/tmp','c:\windows\temp'):
                if os.path.isdir(tmpdir):
                        break
    os.chdir(tmpdir)
    if(not os.path.isdir(os.path.join(tmpdir,'thumb'))):
                os.mkdir('thumb')
    tmpdir = os.path.join(tmpdir,'thumb')
    tmpwork = LocalFS.LocalFS('tmp','bidon',tmpdir,username=None,password=None)
    self._setObject(id, ZPhotoSlides(id,img,tmpwork,tmpdir,thumb_prefix,title))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ZPhotoSlides(
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish.
    Folder,
    Image,
    Persistent,            # Make us persistent. Yaah!
    Acquisition.Implicit,  # Uh, whatever.
    AccessControl.Role.RoleManager # Security manager.
    ):
    
    
    meta_type = 'ZPhotoSlides' # what do people think they're adding?
     
    manage_options = ( # what management options are there?
	               {'label': 'Manage properties',       'action': 'manage_main'},
		       {'label': 'View',       'action': 'view_slides'}, # defaults to index_html
                       {'label': 'List all files', 'action': 'list_files'},
                       {'label': 'Make thumbnails', 'action': 'make_thumb'},
		       {'label': 'Manage photos', 'action': 'change_title'},
	               {'label': 'Security',   'action': 'manage_access'},
		       
                        
		     )
					 
    __ac_permissions__=( # what permissions make sense for us?
		         ('View management screens', ('manage_tabs','manage_main')),
			 ('Change permissions',      ('manage_access',)           ),
		         ('Change ZPhotoSlides'     ,     ('manage_edit',)             ),
#                         ('Change thumbnails titles' ,  ('manage_thumb_title',)      ),
#			 ('View ZPhotoSlides',       ('',)                        ),
		       )
#    index_html = HTMLFile('index', globals()) # View Interface
    list_files = HTMLFile('List_files',globals())
    manage_main = HTMLFile('ZPhotoSlidesEdit', globals()) # Management Interface
    make_thumb = HTMLFile('make_thumb',globals()) # form for making the thumb
    edit_image = HTMLFile('edit_photo',globals())
    change_title = HTMLFile('list_title',globals())

    def __init__(self, id,img,tmpwork,tmpdir,thumb_prefix,title=''):
        """initialise a new instance of Boring"""
        self.id = id
        self.title = title
	self.thumb_prefix = thumb_prefix
	self.image_folder = img
	self.tmp = tmpwork
	self.tmp_dir = tmpdir
        self.img_doc = img.defaultDocument()
	self.thumbnails = Folder()
	self.thumbnails.id = 'thumbnails'
	self.thumbnails.title = 'Thumbnails'
	self.thumbnails._setProperty('amount_photo',0)
        self.script_view = PythonScript.PythonScript('script')
	self.script_view.ZPythonScript_edit('compteur2',
"""
images = context.thumbnails.objectValues('Image')
for img in images:
	if(img.getviewit=='0'):
		images.remove(img)
#print images
images.sort(lambda x, y: cmp(x.position, y.position))
nbr = len(images)
compteur2= int(compteur2)
if compteur2 < 9:
	compteur2 = 9
oldcompteur = compteur2 - 9
nbrimgs = 0
for image in images[oldcompteur:compteur2]:
	nbrimgs = nbrimgs + 1
print '<h2><font color="black">',context.title_or_id(),'</font></h2><br>'
print '<h2 align="right"><font color="blue" align="right"> Picture:',oldcompteur+1,'until',oldcompteur + nbrimgs,' over ',nbr,'pictures</h2></font>'
print '<table align="center">'
compteur = 0
for image in images[oldcompteur:compteur2]:
	compteur = compteur + 1
	if compteur == 1:
		print '<tr>'
	print '<td>'
	imag = image.getId()
	imag = imag[3:]
	print '<center><a href="image_folder/%s">%s</a></center><br>' % (imag,image.tag(alt=image.title_or_id()))
	print '<center><a href="image_folder/%s">%s</a></center>' % (imag,image.title_or_id())
        print '<form action="%s/see_comment">' % (context.REQUEST.URL1)
        print '<input type="hidden" name="photo" value="%s">' % imag
        print '<input type="hidden" name="compteur2" value="%s">' % compteur2
        print '<center><input type="submit" value="See and Add commments"></center>'
        print '</form>'
	print '</td>'
	if compteur == 3:
		print '<tr>'
		compteur = 0
print '</table>'
print '<font="black"><table align="center"><tr>'
if (oldcompteur <> 0):
	print '<td><form action="script_view" method="post">'
	print '<input type="hidden" name="compteur2" value="9">'
	print '<center><input type="submit" value="Go the beginning!"></center>'
	print '</form>'
	print '</td>'
	print '<td>'
	print '<form action="script_view" method="post">'
	print '<input type="hidden" name="compteur2" value="',compteur2 -9,'">'
	print '<center><input type="submit" value="BEFORE!"></center>'
	print '</form></td>'

if (compteur2 < nbr):
	print '<td><form action="script_view" method="post">'
	print '<input type="hidden" name="compteur2" value="',compteur2 + 9,'">'
	print '<center><input type="submit" value="NEXT!"></center>'
	print '</form></td>'
print '<body>'
print '<html>'

if (compteur2 <> nbr):
	print '<td><form action="script_view" method="post">'
	print '<input type="hidden" name="compteur2" value="',nbr,'">'
	print '<center><input type="submit" value="Go the end!"></center>'
	print '</form></td>'
print '</tr></table>'
print '</font>'
return printed
 """)

    def manage_edit(self, title,photo_folder, REQUEST=None):
	"""does this really need a doc string?"""
	self.title = title
	old_basepath = self.image_folder.basepath
        self.image_folder.basepath = photo_folder
	if(old_basepath != photo_folder):
		self.remove_thumbnails()
        if REQUEST is not None:
            return MessageDialog(
                title = 'Edited',
                message = "Properties for %s changed." % self.id,
                action = './manage_main',
                )
    def remove_thumbnails(self):
	for img in self.thumbnails.objectValues('Image'):
		self.thumbnails.manage_delObjects(img.getId())

    def ask_4_thumbnails(self,REQUEST):
        """Make the thumbnails   from the path"""
	prefix = REQUEST.prefix
        scale = int(REQUEST.scale)
        upload = self.REQUEST.upload
    #	print upload
	start_path = self.image_folder.basepath
        try:
           MakeThumbnails(start_path,self.tmp_dir,scale,prefix)
        except:
	    pass
 #          print 'oooops' + ' ' +traceback.print_exc()
	result = 'Thumbnails done in folder %s' % self.tmp_dir
        if(upload=='1'):
	    info = self.upload_thumbnails()
	    result = result + '<br>Thumbnails uploaded in ZODB'
	if (info != ''):
		result = result + '<br><center><b><font color="red">Error on files: %s</b></font></center>' %info
        if REQUEST is not None:
            return MessageDialog(
                title = 'Thumbnails',
                message = result,
                action = 'list_files' ,
                )
    def update_position(self,new_position,old_position):
	for img in self.thumbnails.objectValues('Image'):
		if(img.position == new_position):
			img.position = old_position
				

    def update_photo_prop(self,REQUEST):
        """Update the title of a photo"""
	title = REQUEST.title
	id = REQUEST.id
	new_position = int(REQUEST.position)
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==id):
			oldtitle = img.title
			img.title = title
			old_getviewit = img.getviewit
			old_position = img.position
			if(img.position != new_position):
				self.update_position(new_position,old_position)
			img.position = new_position
			img.getviewit = REQUEST.viewit
	if (oldtitle == title and old_getviewit == REQUEST.viewit and old_position == REQUEST.position):
		result = 'Seems that you didnt change anything of %s' % id
	else:
		result = 'Properties of %s has been updated' % id
        # FIX ME !!!!
	#return self.change_title(REQUEST=REQUEST)
        return MessageDialog(
                title = 'Change Title',
                message = "%s." % result,
                action = 'change_title' ,
                )

    def upload_thumbnails(self):
	"""Upload the thumbnails into the ZODB"""
	print 'cooooooooooooooooooooooool'
	info = ''
	for img in self.tmp.fileValues():
		if(img.id[:len(self.thumb_prefix)]==self.thumb_prefix and img.id[-3:]!='bak'):
			 tmpdir = os.path.join(self.tmp_dir,img.id)
			 start_path = os.path.join(self.image_folder.basepath,img.id)
			 list = self.thumbnails.objectValues()
                         list2 = []
			 for elem in list:
				list2.append(elem.getId())
			 if img.id in list2:
	#			print 'already exist!!'
#				print self.thumbnails.objectValues()
				self.thumbnails.manage_delObjects(img.getId())
			 #data = str(img.getObject())
			 print tmpdir
			 try:	
				 file = open(tmpdir,'r')
				 data = file.read()
				 file.close()
                                 type = OFS.Image.getImageInfo(data)
	                         self.thumbnails.manage_addImage(img.id,data,content_type=type[0])
			 except:
				 print 'error on : %s' % img.id
		else:
			print 'NON!!!!!!!!!!!!!'
	prop_id = 'getviewit'
	prop2_id = 'position'
        cpt = 0  
 	for imag in self.thumbnails.objectValues('Image'):
        #       	print imag.getId()
        	imag._setProperty(prop2_id.strip(),cpt)
		cpt = cpt + 1
 		imag._setProperty(prop_id.strip(), '1')
	self.thumbnails.amount_photo = cpt
	return info
	
    def image_modif(self,REQUEST):
        """Modify an image """
	image = REQUEST.file
        angle = REQUEST.angle
	path = self.image_folder.basepath
	abspath = path + '/' + image
	img = Image_modif(abspath)
        img.make_backup()
	modif = 0
	if(hasattr(REQUEST,'rotate') and REQUEST.rotate=='on'):	
		img.getrotate(angle)
		modif = 1
	if(hasattr(REQUEST,'grayscale') and REQUEST.grayscale=='on'):
		img.remove_color()
		modif = 1
	if(hasattr(REQUEST,'change_size') and REQUEST.change_size=='on'):
		modif = 1
		width = float(REQUEST.width)
		height = float(REQUEST.height)
		if(hasattr(REQUEST,'keep_ratio') and REQUEST.keep_ratio=='on'):
			oldheight = float(REQUEST.old_height)
			oldwidth = float(REQUEST.old_width)
			ratio = oldwidth/oldheight
			if(oldheight!=height and oldwidth==width): # height is modified
				width = ratio * height
			elif(oldheight==height and oldwidth!=width): # width is modified
			#	print ratio
			#	print ' coool '
				height = width/ratio
			#	print height
			elif(oldheight!=height and oldwidth!=width):
				width = ratio * height		
			img.resize_image(int(height),int(width),ratio)
		else:
			img.resize_image(height,width,0)
	if (modif==0):
	        return MessageDialog(
		        title = 'Image Modification',
			message =  'Nothing has to be done on image %s!' % image,
			action = 'list_files',
			)
	img.save_modif()
	if REQUEST is not None:
                return MessageDialog(
                 title = 'Image Modification',
                 message = "Modification for %s done." % image,
                 action = 'list_files' ,
                 )
    def get_image_info(self,image_name):
	"""Get all the informations about an image"""
	path = self.image_folder.basepath
	abspath = path + '/' + image_name
	img = Image_modif(abspath)
	dict = img.get_info()
	return dict

    def undo_modif(self,REQUEST):
	"""Undo a previous modification of an image"""
	image = REQUEST.file
	bak = image + '.bak'
	path = self.image_folder.basepath
	new = os.path.join(path,image)
	backup = os.path.join(path,bak)
#	print backup
	if os.path.exists(backup):
	    cmd = 'mv ' + backup + ' ' + new
            os.popen(cmd)
            return MessageDialog(
                title = 'Undo',
                message = "Undo successfull !",
                action = 'list_files' ,
                )	
	else:
	    return MessageDialog(
                title = 'Undo',
                message = "Sorry, undo can't be done for this image.",
                action = 'list_files' ,
                )
                
    def notthumb(self,id):
	self.thumb_prefix_size = len(self.thumb_prefix)
	result = 1
	if(id[:self.thumb_prefix_size]==self.thumb_prefix):
		result = 0
	return result
	

    def view_slides(self,REQUEST=None):
	"""print index_html"""
        try: 
	    return self.script_view(9)
	except:
	    print traceback.print_exc()

